<?php
session_start();

include_once('lib.php');

$msg = "";
$err = "";
$redirect = "";
$astro = IsAstro();
$wifi_connected = false;
if (!isset($_SESSION['ssidList'])) {
  $_SESSION['ssidList'] = array();
}

if (isset($_POST["upload"])) {
  TryUploadUpdate();
} else if(isset($_POST["update"])) {
  TryWebUpdate();
} else if(isset($_POST["eth-submit"])) {
  ProcessForm();
} else if(isset($_POST["wifi-connect"])) {
  ProcessWifiForm(true);
} else if(isset($_POST["wifi-disconnect"])) {
  ProcessWifiForm(false);
}

$cameras = $astro ? EnumerateCamerasAstro() : EnumerateCamerasDC();

header("Cache-Control: no-cache, must-revalidate");
header("Expires: Sat, 26 Jul 1997 05:00:00 GMT");

if ($redirect != "") { ?>
<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8" />
  <meta http-equiv="refresh" content="2;URL='http://<?php echo $redirect; ?>/'">
  <style type="text/css">body {font-size: 16px;}</style>
</head>
<body>
Redirecting...
</body>
</html>
<?php } else { ?>
<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8" />
  <title><?php if ($astro) echo 'Moravian Camera Ethernet Adapter'; else echo 'DataCam ETH Adapter'; ?></title>
  <link rel="stylesheet" type="text/css" href="style.css?v=3" />
  <link rel="shortcut icon" href="favicon.ico">
  <script type="text/javascript" src="lib.js?v=3"></script>
</head>
<body>
  <table id="top">
    <tr>
    <td style="width: 420px;" class="tal">
        <span class="fs24"><?php if ($astro) echo 'Moravian Camera Ethernet Adapter'; else echo 'DataCam ETH Adapter'; ?></span>
        <span style="padding-left: 20px;">configuration</span>
      </td>
    <td style="width: 200px; font-size: 10px;" class="tar">You will be logged out in <span style="color: red;" id="timer"><?php readfile("/run/lighttpd/timer"); ?></span> s</td>
      <td style="width: 80px;" class="tar">
  <a href="<?php if ($astro) echo 'http://www.gxccd.com'; else echo 'http://www.mii.cz'; ?>" target="_blank"><img src="logo.jpg" alt="Moravian Instruments Inc." width="60" height="60"></a>
      </td>
    </tr>
  </table>
  <hr />
  <form method="post" action="<?php echo $_SERVER['PHP_SELF'];?>">
    <table class="bottom">
      <tr>
        <th class="fc tac" colspan="2">Ethernet + Basic Info</th>
      </tr>
    <?php if (IsLANConnected()) { ?>
      <tr>
        <td class="fc">IP Address:</td>
        <td class="sc">
          <?php
            $ip = explode (".", GetIP());
            echo "<input class=\"ip\" type=\"text\" name=\"a0\" value=\"$ip[0]\" maxlength=\"3\" onchange=\"TestByte(this)\"><span class=\"fs18\"> . </span>";
            echo "<input class=\"ip\" type=\"text\" name=\"a1\" value=\"$ip[1]\" maxlength=\"3\" onchange=\"TestByte(this)\"><span class=\"fs18\"> . </span>";
            echo "<input class=\"ip\" type=\"text\" name=\"a2\" value=\"$ip[2]\" maxlength=\"3\" onchange=\"TestByte(this)\"><span class=\"fs18\"> . </span>";
            echo "<input class=\"ip\" type=\"text\" name=\"a3\" value=\"$ip[3]\" maxlength=\"3\" onchange=\"TestByte(this)\">\n";
          ?>
        </td>
      </tr>
      <tr>
        <td class="fc">Netmask:</td>
        <td class="sc">
          <?php
            $nm = explode (".", GetNetmask());
            echo "<input class=\"ip\" type=\"text\" name=\"n0\" value=\"$nm[0]\" maxlength=\"3\" onchange=\"TestByte(this)\"><span class=\"fs18\"> . </span>";
            echo "<input class=\"ip\" type=\"text\" name=\"n1\" value=\"$nm[1]\" maxlength=\"3\" onchange=\"TestByte(this)\"><span class=\"fs18\"> . </span>";
            echo "<input class=\"ip\" type=\"text\" name=\"n2\" value=\"$nm[2]\" maxlength=\"3\" onchange=\"TestByte(this)\"><span class=\"fs18\"> . </span>";
            echo "<input class=\"ip\" type=\"text\" name=\"n3\" value=\"$nm[3]\" maxlength=\"3\" onchange=\"TestByte(this)\">\n";
          ?>
        </td>
      </tr>
      <tr>
        <td class="fc">Gateway:</td>
        <td class="sc">
          <?php
            $gw = explode (".", GetGateway());
            echo "<input class=\"ip\" type=\"text\" name=\"g0\" value=\"$gw[0]\" maxlength=\"3\" onchange=\"TestByte(this)\"><span class=\"fs18\"> . </span>";
            echo "<input class=\"ip\" type=\"text\" name=\"g1\" value=\"$gw[1]\" maxlength=\"3\" onchange=\"TestByte(this)\"><span class=\"fs18\"> . </span>";
            echo "<input class=\"ip\" type=\"text\" name=\"g2\" value=\"$gw[2]\" maxlength=\"3\" onchange=\"TestByte(this)\"><span class=\"fs18\"> . </span>";
            echo "<input class=\"ip\" type=\"text\" name=\"g3\" value=\"$gw[3]\" maxlength=\"3\" onchange=\"TestByte(this)\">\n";
          ?>
        </td>
      </tr>
      <tr>
        <td class="fc">DNS:</td>
        <td class="sc">
          <?php
            $dns = explode (".", GetDNS());
            echo "<input class=\"ip\" type=\"text\" name=\"d0\" value=\"$dns[0]\" maxlength=\"3\" onchange=\"TestByte(this)\"><span class=\"fs18\"> . </span>";
            echo "<input class=\"ip\" type=\"text\" name=\"d1\" value=\"$dns[1]\" maxlength=\"3\" onchange=\"TestByte(this)\"><span class=\"fs18\"> . </span>";
            echo "<input class=\"ip\" type=\"text\" name=\"d2\" value=\"$dns[2]\" maxlength=\"3\" onchange=\"TestByte(this)\"><span class=\"fs18\"> . </span>";
            echo "<input class=\"ip\" type=\"text\" name=\"d3\" value=\"$dns[3]\" maxlength=\"3\" onchange=\"TestByte(this)\">\n";
          ?>
        </td>
      </tr>
    <?php } else { // LAN not connected ?>
      <tr>
        <td class="fc">Status:</td>
        <td class="sc fs15" style="color: red;">Disconnected</td>
      </tr>
    <?php } ?>
      <tr>
        <td class="fc">Port:</td>
        <td class="sc">
          <?= "<input type=\"text\" name=\"po\" value=\"" . GetPort() . "\" maxlength=\"5\" onchange=\"TestPort(this)\">\n"; ?>
        </td>
      </tr>
      <tr>
        <td class="fc">Hostname:</td>
        <td class="sc">
          <?= "<input type=\"text\" name=\"hn\" value=\"" . gethostname() ."\" maxlength=\"64\">\n"; ?>
        </td>
      </tr>
      <tr>
        <td class="fc">MAC Address:</td>
        <td class="sc ffs fs15"><?= GetMAC(); ?></td>
      </tr>
<?php if ($astro) { ?>
      <tr>
        <th class="fc tac" colspan="2">Serial Port Info</th>
      </tr>
      <tr>
        <td class="fc">Serial Port <strong>A</strong></td>
        <td class="sc">
          <?= "<input type=\"text\" name=\"spa\" value=\"" . GetSerialPort(0) . "\" maxlength=\"5\" onchange=\"TestPort(this)\">\n"; ?>
        </td>
      </tr>
<?php if (!IsARM()) { ?>
      <tr>
        <td class="fc">Serial Port <strong>B</strong></td>
        <td class="sc">
          <?= "<input type=\"text\" name=\"spb\" value=\"" . GetSerialPort(1) . "\" maxlength=\"5\" onchange=\"TestPort(this)\">\n"; ?>
        </td>
      </tr>
<?php } // ! IsARM() ?>
<?php } // $astro ?>
      <tr>
        <th class="fc tac" colspan="2">Connected Cameras Info</th>
      </tr>
<?php
      if ($cameras === false) {
?>
      <tr>
        <td class="fc"></td>
        <td class="sc fs15 error">No cameras connected</td>
      </tr>
<?php
      } else {
        foreach ($cameras as $index => $info) {
          $i = $index + 1;
          $cl = '';
          $usb = '';
          switch ($info['status']) {
            case 0: $cl = 'error'; $usb = 'error'; break;
            case 1: $cl = 'msg';   $usb = 'error'; break;
            case 2: $cl = 'error'; $usb = 'msg'; break;
            case 3: $cl = 'msg';   $usb = 'msg'; break;
          }
          $conn = ", Connected: <span class=\"$cl\">Client</span>, <span class=\"$usb\">USB</span>";
?>
      <tr>
        <td class="fc">Camera <strong>#<?= $i ?></strong></td>
        <td class="sc fs15"><?= $info['desc'] . ', Id: ' . $info['id'] . ', Serial: ' . $info['serial'] . $conn ?></td>
      </tr>
<?php
        }
      } // $cameras
?>
    </table>
    <table>
      <tr>
        <td class="sc tar" colspan="2"><input type="submit" name="eth-submit" value="Submit"></td>
      <tr>
    </table>
  </form>
  <hr />
<?php if (HasWLAN()) { ?>
  <form method="post" enctype="multipart/form-data" action="<?= $_SERVER['PHP_SELF']; ?>">
    <table class="bottom">
      <tr>
        <th class="fc tac" colspan="2">Wi-Fi Adapter</th>
      </tr>
      <tr>
        <td class="fc">Status:</td>
        <?php
          $res = WLANGetStatusAndESSID();
          $wifi_connected = $res['conn'];
          if ($wifi_connected) {
            echo "<td class=\"sc fs15\" style=\"color: green;\">Connected to: <b>" . $res['ssid'] . "</b></td>";
          } else {
            echo "<td class=\"sc fs15\" style=\"color: red;\">Disconnected</td>";
          }
        ?>
      </tr>
<?php if ($wifi_connected) { ?>
      <tr>
        <td class="fc">IP Address:</td>
        <td class="sc ffs fs15"><?php echo GetIP(true); ?></td>
      </tr>
      <tr>
        <td class="fc">Netmask:</td>
        <td class="sc ffs fs15"><?php echo GetNetmask(true); ?></td>
      </tr>
      <tr>
        <td class="fc">Gateway:</td>
        <td class="sc ffs fs15"><?php echo GetGateway(true); ?></td>
      </tr>
      <tr>
        <td class="fc">DNS:</td>
        <td class="sc ffs fs15"><?php echo GetDNS(); ?></td>
      </tr>
<?php } else { // !$wifi_connected ?>
      <tr>
        <td class="fc">Available networks:</td>
        <td class="sc">
          <select name="essid">
            <?php
              $ssids = WLANGetNetworkList();
              foreach ($ssids as $key => $value) {
                echo "<option value=\"$key\">$key (strength: $value[signal]%)</option>\n";
              }
            ?>
            <option value="no-scanned-ssid">&lt;none&gt;</option>
          </select>
          <input type="submit" name="wifi-scan" value="Scan">
        </td>
      </tr>
<?php /*
      <tr>
        <td class="fc">Network name (ESSID):</td>
        <td class="sc">
          <input type="text" name="essid-hidden" />
        </td>
      </tr>
*/ ?>
      <tr>
        <td class="fc">Password:</td>
        <td class="sc">
          <input type="password" name="essid-pass" />
        </td>
      </tr>
      <tr>
        <td class="fc">IP Address:</td>
        <td class="sc">
          <select name="wifi-ip-type" onchange="essidChangeEventHandler(event);">
            <option value="static" selected>Static</option>
            <option value="dhcp">DHCP (Automatic)</option>
          </select>
        </td>
      </tr>
      <tr class="r-static">
        <td class="fc"></td>
        <td class="sc">
            <input class="ip" type="text" name="wifi-a0" value="" maxlength="3" onchange="TestByte(this);"><span class="fs18"> . </span>
            <input class="ip" type="text" name="wifi-a1" value="" maxlength="3" onchange="TestByte(this);"><span class="fs18"> . </span>
            <input class="ip" type="text" name="wifi-a2" value="" maxlength="3" onchange="TestByte(this);"><span class="fs18"> . </span>
            <input class="ip" type="text" name="wifi-a3" value="" maxlength="3" onchange="TestByte(this);">
        </td>
      </tr>
      <tr class="r-static">
        <td class="fc">Netmask:</td>
        <td class="sc">
            <input class="ip" type="text" name="wifi-n0" value="" maxlength="3" onchange="TestByte(this);"><span class="fs18"> . </span>
            <input class="ip" type="text" name="wifi-n1" value="" maxlength="3" onchange="TestByte(this);"><span class="fs18"> . </span>
            <input class="ip" type="text" name="wifi-n2" value="" maxlength="3" onchange="TestByte(this);"><span class="fs18"> . </span>
            <input class="ip" type="text" name="wifi-n3" value="" maxlength="3" onchange="TestByte(this);">
        </td>
      </tr>
      <tr class="r-static">
        <td class="fc">Gateway:</td>
        <td class="sc">
            <input class="ip" type="text" name="wifi-g0" value="" maxlength="3" onchange="TestByte(this);"><span class="fs18"> . </span>
            <input class="ip" type="text" name="wifi-g1" value="" maxlength="3" onchange="TestByte(this);"><span class="fs18"> . </span>
            <input class="ip" type="text" name="wifi-g2" value="" maxlength="3" onchange="TestByte(this);"><span class="fs18"> . </span>
            <input class="ip" type="text" name="wifi-g3" value="" maxlength="3" onchange="TestByte(this);">
        </td>
      </tr>
      <tr class="r-static">
        <td class="fc">DNS:</td>
        <td class="sc">
            <input class="ip" type="text" name="wifi-d0" value="" maxlength="3" onchange="TestByte(this);"><span class="fs18"> . </span>
            <input class="ip" type="text" name="wifi-d1" value="" maxlength="3" onchange="TestByte(this);"><span class="fs18"> . </span>
            <input class="ip" type="text" name="wifi-d2" value="" maxlength="3" onchange="TestByte(this);"><span class="fs18"> . </span>
            <input class="ip" type="text" name="wifi-d3" value="" maxlength="3" onchange="TestByte(this);">
        </td>
      </tr>
<?php } // $wifi_connected ?>
      <tr>
        <td class="fc">MAC Address:</td>
        <td class="sc ffs fs15"><?php echo GetMAC(true); ?></td>
      </tr>
    </table>
    <table>
      <tr>
        <td class="sc tar" colspan="2">
        <?php
          if ($wifi_connected)
            echo "<input type=\"submit\" name=\"wifi-disconnect\" value=\"Disconnect\">";
          else
            echo "<input type=\"submit\" name=\"wifi-connect\" value=\"Connect\">";
        ?>
        </td>
      <tr>
    </table>
  </form>
  <hr />
<?php } ?>
  <form method="post" enctype="multipart/form-data" action="<?php echo $_SERVER['PHP_SELF'];?>">
    <input type="hidden" name="MAX_FILE_SIZE" value="60000000" />
    <table class="bottom">
      <tr>
        <th class="fc tac" colspan="2">Update</th>
      </tr>
      <tr>
        <td class="fc">Version:</td>
        <td class="sc"><?php echo GetVersionNum(); ?></td>
      </tr>
      <tr>
        <td class="fc">Update from <?php if ($astro) echo 'www.gxccd.com'; else echo 'www.mii.cz'; ?>:</td>
        <td class="sc"><input type="submit" name="update" value="Update" /></td>
      </tr>
      <tr>
        <td class="fc">Update from file:</td>
        <td class="sc"><input name="userfile" type="file" /><input type="submit" name="upload" value="Upload" /></td>
      </tr>
    </table>
  </form>
<?php
  if ($err != "") {
    echo "<div class=\"msg-box error\">$err</div>";
  }
  if ($msg != "") {
    echo "<div class=\"msg-box msg\">$msg</div>";
  }
?>
  <script type="text/javascript">SetTimer(); RunTimer();</script>
</body>
</html>
<?php } ?>
